// FtException.cpp: CFtException NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FtException.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


CFtException::CFtException(FT_STATUS nStatus, const char* szFunc)
{
	m_nStatus	= nStatus;
	m_strFunc	= szFunc;
}

CFtException::~CFtException()
{

}

CString CFtException::GetErrorMessage()
{
	CString	strErrMsg;

	strErrMsg.Format("%s : %s (Sta=%d)", m_strFunc, GetFtStatusStr(m_nStatus), m_nStatus);

	return	strErrMsg;
}

int CFtException::ReportError(UINT nType)
{
	return	AfxMessageBox(GetErrorMessage(), nType);
}

const char* CFtException::GetFtStatusStr(FT_STATUS nStatus) const
{
	switch(nStatus)
	{
    case FT_OK:
		return	"FT_OK";

	case FT_INVALID_HANDLE:
		return	"FT_INVALID_HANDLE";

	case FT_DEVICE_NOT_FOUND:
		return	"FT_DEVICE_NOT_FOUND";

	case FT_DEVICE_NOT_OPENED:
		return	"FT_DEVICE_NOT_OPENED";

	case FT_IO_ERROR:
		return	"FT_IO_ERROR";

	case FT_INSUFFICIENT_RESOURCES:
		return	"FT_INSUFFICIENT_RESOURCES";

	case FT_INVALID_PARAMETER:
		return	"FT_INVALID_PARAMETER";

	case FT_INVALID_BAUD_RATE:
		return	"FT_INVALID_BAUD_RATE";

	case FT_DEVICE_NOT_OPENED_FOR_ERASE:
		return	"FT_DEVICE_NOT_OPENED_FOR_ERASE";

	case FT_DEVICE_NOT_OPENED_FOR_WRITE:
		return	"FT_DEVICE_NOT_OPENED_FOR_WRITE";

	case FT_FAILED_TO_WRITE_DEVICE:
		return	"FT_FAILED_TO_WRITE_DEVICE";

	case FT_EEPROM_READ_FAILED:
		return	"FT_EEPROM_READ_FAILED";

	case FT_EEPROM_WRITE_FAILED:
		return	"FT_EEPROM_WRITE_FAILED";

	case FT_EEPROM_ERASE_FAILED:
		return	"FT_EEPROM_ERASE_FAILED";

	case FT_EEPROM_NOT_PRESENT:
		return	"FT_EEPROM_NOT_PRESENT";

	case FT_EEPROM_NOT_PROGRAMMED:
		return	"FT_EEPROM_NOT_PROGRAMMED";

	case FT_INVALID_ARGS:
		return	"FT_INVALID_ARGS";

	case FT_NOT_SUPPORTED:
		return	"FT_NOT_SUPPORTED";

	case FT_OTHER_ERROR:	
		return	"FT_OTHER_ERROR";
	}

	return	"undefined FT_STATUS value.";
}

